import { PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class ScsCoursesource {
  [PrimaryKeyProp]?: 'Id';
  Id!: bigint;
  CourseId!: bigint;
  Name?: string;
  Type!: number;
  Extension?: string;
  Url?: string;
  ExpireTime?: Date;
  VideoId?: string;
  Revision!: number;
  CreatedBy?: bigint;
  CreatedTime!: Date;
  UpdatedBy?: bigint;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const ScsCoursesourceSchema = defineEntity({
  class: ScsCoursesource,
  comment: '课程资源',
  properties: {
    Id: p.bigint().primary().name('Id').unsigned(false).autoincrement(false).comment('主键Id'),
    CourseId: p.bigint().name('CourseId').comment('课程id'),
    Name: p.string().name('Name').nullable().comment('名称'),
    Type: p.integer().name('Type').comment('类型'),
    Extension: p.string().name('Extension').nullable().comment('文件扩展名称'),
    Url: p.string().name('Url').length(1000).nullable().comment('文件地址'),
    ExpireTime: p.datetime().name('ExpireTime').length(3).nullable().comment('失效时间'),
    VideoId: p.string().name('VideoId').nullable().comment('视频Id'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
